SoVRMLInline(3)

NAME
SoVRMLInline - The SoVRMLInline class is used to insert VRML files into a scene.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLInline.h>

Inherits SoNode.

  Public Types
enum BboxVisibility { NEVER, UNTIL_LOADED, ALWAYS }
Public Types inherited from SoNode
enum NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000, COIN_4_0 = 0x20000 }

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLInline (void)
void setFullURLName (const SbString &url)
const SbString & getFullURLName (void)
SoGroup * copyChildren (void) const
void requestURLData (void)
SbBool isURLDataRequested (void) const
SbBool isURLDataHere (void) const
void cancelURLDataRequest (void)
void setChildData (SoNode *urlData)
SoNode * getChildData (void) const
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void search (SoSearchAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SoChildList * getChildren (void) const
Public Member Functions inherited from SoNode
void setOverride (const SbBool state)
SbBool isOverride (void) const
void setNodeType (const NodeType type)
NodeType getNodeType (void) const
virtual SoNode * copy (SbBool copyconnections=FALSE) const
virtual SbBool affectsState (void) const
virtual void GLRenderBelowPath (SoGLRenderAction *action)
virtual void GLRenderInPath (SoGLRenderAction *action)
virtual void GLRenderOffPath (SoGLRenderAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void write (SoWriteAction *action)
virtual void audioRender (SoAudioRenderAction *action)
virtual void grabEventsSetup (void)
virtual void grabEventsCleanup (void)
virtual void startNotify (void)
virtual void notify (SoNotList *l)
SbUniqueId getNodeId (void) const
virtual void writeInstance (SoOutput *out)
virtual SoNode * addToCopyDict (void) const
virtual SoFieldContainer * copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void setToDefaults (void)
SbBool hasDefaultValues (void) const
SbBool fieldsAreEqual (const SoFieldContainer *container) const
void copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool set (const char *const fielddata)
void get (SbString &fielddata)
virtual int getFields (SoFieldList &l) const
virtual int getAllFields (SoFieldList &l) const
virtual SoField * getField (const SbName &name) const
virtual SoField * getEventIn (const SbName &name) const
virtual SoField * getEventOut (const SbName &name) const
SbBool getFieldName (const SoField *const field, SbName &name) const
SbBool enableNotify (const SbBool flag)
SbBool isNotifyEnabled (void) const
SbBool set (const char *fielddata, SoInput *input)
void get (SbString &fielddata, SoOutput *out)
virtual SbBool validateNewFieldValue (SoField *field, void *newval)
virtual void addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool getIsBuiltIn (void) const
virtual void getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void setUserData (void *userdata) const
void * getUserData (void) const
Public Member Functions inherited from SoBase
void ref (void) const
void unref (void) const
void unrefNoDelete (void) const
int32_t getRefCount (void) const
void touch (void)
SbBool isOfType (SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
virtual SbName getName (void) const
virtual void setName (const SbName &newname)
void addAuditor (void *const auditor, const SoNotRec::Type type)
void removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & getAuditors (void) const
SbBool shouldWrite (void)
void assertAlive (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
static void setFetchURLCallBack (SoVRMLInlineFetchURLCB *f, void *closure)
static void setBoundingBoxVisibility (BboxVisibility b)
static BboxVisibility getBoundingBoxVisibility (void)
static void setBoundingBoxColor (SbColor &color)
static SbColor & getBoundingBoxColor (void)
static void setReadAsSoFile (SbBool enable)
static SbBool getReadAsSoFile (void)
Static Public Member Functions inherited from SoNode
static uint32_t getCompatibilityTypes (const SoType &nodetype)
static SoType getClassTypeId (void)
static SoNode * getByName (const SbName &name)
static int getByName (const SbName &name, SoNodeList &l)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SbUniqueId getNextNodeId (void)
static int getActionMethodIndex (const SoType type)
static void getBoundingBoxS (SoAction *action, SoNode *node)
static void GLRenderS (SoAction *action, SoNode *node)
static void callbackS (SoAction *action, SoNode *node)
static void getMatrixS (SoAction *action, SoNode *node)
static void handleEventS (SoAction *action, SoNode *node)
static void pickS (SoAction *action, SoNode *node)
static void rayPickS (SoAction *action, SoNode *node)
static void searchS (SoAction *action, SoNode *node)
static void writeS (SoAction *action, SoNode *node)
static void audioRenderS (SoAction *action, SoNode *node)
static void getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void cleanupClass (void)
static void initCopyDict (void)
static void addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void copyDone (void)
Static Public Member Functions inherited from SoBase
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void addName (SoBase *const base, const char *const name)
static void removeName (SoBase *const base, const char *const name)
static void incrementCurrentWriteCounter (void)
static void decrementCurrentWriteCounter (void)
static SoBase * getNamedBase (const SbName &name, SoType type)
static int getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool read (SoInput *input, SoBase *&base, SoType expectedtype)
static void setInstancePrefix (const SbString &c)
static void setTraceRefs (SbBool trace)
static SbBool getTraceRefs (void)
static SbBool connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool readRoute (SoInput *input)

  Public Attributes
SoSFVec3f bboxCenter
SoSFVec3f bboxSize
SoMFString url

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVRMLInline ()
Protected Member Functions inherited from SoNode
SoNode (void)
virtual ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
SoFieldContainer (void)
virtual ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
SoBase (void)
virtual ~SoBase ()
virtual void destroy (void)
SbBool hasMultipleWriteRefs (void) const
SbBool writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void writeFooter (SoOutput *out) const
virtual const char * getFileFormatName (void) const
virtual SoNotRec createNotRec (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** getFieldDataPtr (void)
static void setNextActionMethodIndex (int index)
static int getNextActionMethodIndex (void)
static void incNextActionMethodIndex (void)
static void setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t getCurrentWriteCounter (void)
static void staticDataLock (void)
static void staticDataUnlock (void)

  Additional Inherited Members
Protected Types inherited from SoBase
enum BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId nextUniqueId = 1
static int nextActionMethodIndex = 0

Detailed Description

The SoVRMLInline class is used to insert VRML files into a scene. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

Inline {
  exposedField MFString url        []
  field        SFVec3f  bboxCenter 0 0 0     # (-,)
  field        SFVec3f  bboxSize   -1 -1 -1  # (0,) or -1,-1,-1
}

The Inline node is a grouping node that reads its children data from a location in the World Wide Web. Exactly when its children are read and displayed is not defined (e.g. reading the children may be delayed until the Inline node's bounding box is visible to the viewer). The url field specifies the URL containing the children. An Inline node with an empty URL does nothing.

Each specified URL shall refer to a valid VRML file that contains a list of children nodes, prototypes, and routes at the top level as described in 4.6.5, Grouping and children nodes.

The results are undefined if the URL refers to a file that is not VRML or if the VRML file contains non-children nodes at the top level.

If multiple URLs are specified, the browser may display a URL of a lower preference VRML file while it is obtaining, or if it is unable to obtain, the higher preference VRML file. Details on the url field and preference order can be found in 4.5, VRML and the World Wide Web (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.5).

The results are undefined if the contents of the URL change after it has been loaded.

The bboxCenter and bboxSize fields specify a bounding box that encloses the Inline node's children. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. A default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and if needed shall be calculated by the browser. A description of the bboxCenter and bboxSize fields is in 4.6.4, Bounding boxes (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.4).

Member Enumeration Documentation

  enum SoVRMLInline::BboxVisibility

Enumerator

NEVER
    SoSFVec3f SoVRMLInline::bboxCenter Center of bounding box.

SoSFVec3f SoVRMLInline::bboxSize Size of bounding box.

SoMFString SoVRMLInline::url The VRML file URL.

enum SoVRMLInline::BboxVisibility Used to enumerate bounding box visibility settings.

Never display bounding box.

UNTIL_LOADED
    Display bounding box until file is loaded.

ALWAYS
    Always display bounding box.

Constructor & Destructor Documentation

  SoVRMLInline::SoVRMLInline (void )
Constructor

  SoVRMLInline::~SoVRMLInline () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLInline::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLInline::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

  const SoFieldData ** SoVRMLInline::getFieldDataPtr (void ) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLInline::getFieldData (void ) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoVRMLInline::initClass (void ) [static]

  void SoVRMLInline::setFullURLName (const SbString & urlref)
Sets the full (non-relative) URL name.

  const SbString & SoVRMLInline::getFullURLName (void )
Returns the full URL name.

  SoGroup * SoVRMLInline::copyChildren (void ) const
Returns a copy of the children.

  void SoVRMLInline::requestURLData (void )
Request URL data.

  SbBool SoVRMLInline::isURLDataRequested (void ) const
Returns TRUE if the URL data have been requested.

  SbBool SoVRMLInline::isURLDataHere (void ) const
Returns TRUE if the data have been loaded.

  void SoVRMLInline::cancelURLDataRequest (void )
Cancel the URL data request.

  void SoVRMLInline::setChildData (SoNode * urldata)
Sets the child data. Can be used by the URL fetch callback.

  SoNode * SoVRMLInline::getChildData (void ) const
Returns the child data (the scene loaded from the URL).

  void SoVRMLInline::setFetchURLCallBack (SoVRMLInlineFetchURLCB * f, void * closure) [static]
Sets the callback used to handle URL loading.

  void SoVRMLInline::setBoundingBoxVisibility (BboxVisibility b) [static]
Sets the bounding box visibility strategy.

  SoVRMLInline::BboxVisibility SoVRMLInline::getBoundingBoxVisibility (void ) [static]
Returns the bounding box visibility strategy.

  void SoVRMLInline::setBoundingBoxColor (SbColor & color) [static]
Sets the color of the bounding box.

  SbColor & SoVRMLInline::getBoundingBoxColor (void ) [static]
Returns the color of the bounding box.

  void SoVRMLInline::setReadAsSoFile (SbBool enable) [static]
Sets whether Inline nodes should be treated as a normal Inventor SoFile node.

  SbBool SoVRMLInline::getReadAsSoFile (void ) [static]
Returns whether Inline nodes are read as SoFile nodes.

  void SoVRMLInline::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoVRMLInline::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoVRMLInline::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoVRMLInline::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoVRMLInline::getMatrix (SoGetMatrixAction * action) [virtual]
Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

  void SoVRMLInline::handleEvent (SoHandleEventAction * action) [virtual]
Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoNode.

  void SoVRMLInline::search (SoSearchAction * action) [virtual]
Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
    SoSearchAction

Reimplemented from SoNode.

  void SoVRMLInline::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoVRMLInline::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

  SoChildList * SoVRMLInline::getChildren (void ) const [virtual]
Returns list of children for this node.

Reimplemented from SoNode.

Author

Generated automatically by Doxygen for Coin from the source code.